diff --git a/drivers/net/iavf/iavf_hash.c b/drivers/net/iavf/iavf_hash.c
index a253d08f6..bb51b76b5 100644
--- a/drivers/net/iavf/iavf_hash.c
+++ b/drivers/net/iavf/iavf_hash.c
@@ -35,9 +35,10 @@ enum iavf_pattern_hint_type {
 	IAVF_PHINT_IPV6_SCTP			= 0x00000080,
 	IAVF_PHINT_C_VLAN			= 0x00000100,
 	IAVF_PHINT_S_VLAN			= 0x00000200,
-	IAVF_PHINT_IPV4_GTPU_EH			= 0x00000400,
-	IAVF_PHINT_IPV4_GTPU_EH_DWNLINK		= 0x00000800,
-	IAVF_PHINT_IPV4_GTPU_EH_UPLINK		= 0x00001000,
+	IAVF_PHINT_IPV4_GTPU_IP			= 0x00000400,
+	IAVF_PHINT_IPV4_GTPU_EH			= 0x00000800,
+	IAVF_PHINT_IPV4_GTPU_EH_DWNLINK		= 0x00001000,
+	IAVF_PHINT_IPV4_GTPU_EH_UPLINK		= 0x00002000,
 };
 
 #define IAVF_GTPU_EH_DWNLINK	0
@@ -94,6 +95,8 @@ static struct iavf_pattern_match_type phint_eth_ipv4_tcp = {
 	IAVF_PHINT_IPV4_TCP};
 static struct iavf_pattern_match_type phint_eth_ipv4_sctp = {
 	IAVF_PHINT_IPV4_SCTP};
+static struct iavf_pattern_match_type phint_eth_ipv4_gtpu_ipv4 = {
+	IAVF_PHINT_IPV4};
 static struct iavf_pattern_match_type phint_eth_ipv4_gtpu_eh_ipv4 = {
 	IAVF_PHINT_IPV4};
 static struct iavf_pattern_match_type phint_eth_ipv4_gtpu_eh_ipv4_udp = {
@@ -102,6 +105,8 @@ static struct iavf_pattern_match_type phint_eth_ipv4_gtpu_eh_ipv4_tcp = {
 	IAVF_PHINT_IPV4_TCP};
 static struct iavf_pattern_match_type phint_eth_ipv4_esp = {
 	IAVF_PHINT_IPV4};
+static struct iavf_pattern_match_type phint_eth_ipv4_udp_esp = {
+	IAVF_PHINT_IPV4_UDP};
 static struct iavf_pattern_match_type phint_eth_ipv4_ah = {
 	IAVF_PHINT_IPV4};
 static struct iavf_pattern_match_type phint_eth_ipv4_l2tpv3 = {
@@ -120,6 +125,8 @@ static struct iavf_pattern_match_type phint_eth_ipv6_sctp = {
 	IAVF_PHINT_IPV6_SCTP};
 static struct iavf_pattern_match_type phint_eth_ipv6_esp = {
 	IAVF_PHINT_IPV6};
+static struct iavf_pattern_match_type phint_eth_ipv6_udp_esp = {
+	IAVF_PHINT_IPV6_UDP};
 static struct iavf_pattern_match_type phint_eth_ipv6_ah = {
 	IAVF_PHINT_IPV6};
 static struct iavf_pattern_match_type phint_eth_ipv6_l2tpv3 = {
@@ -140,6 +147,8 @@ static struct iavf_pattern_match_item iavf_hash_pattern_list[] = {
 	{iavf_pattern_eth_ipv4_udp, IAVF_INSET_NONE, &phint_eth_ipv4_udp},
 	{iavf_pattern_eth_ipv4_tcp, IAVF_INSET_NONE, &phint_eth_ipv4_tcp},
 	{iavf_pattern_eth_ipv4_sctp, IAVF_INSET_NONE, &phint_eth_ipv4_sctp},
+	{iavf_pattern_eth_ipv4_gtpu_ipv4, IAVF_INSET_NONE,
+					&phint_eth_ipv4_gtpu_ipv4},
 	{iavf_pattern_eth_ipv4_gtpu_eh_ipv4, IAVF_INSET_NONE,
 					&phint_eth_ipv4_gtpu_eh_ipv4},
 	{iavf_pattern_eth_ipv4_gtpu_eh_ipv4_udp, IAVF_INSET_NONE,
@@ -147,6 +156,8 @@ static struct iavf_pattern_match_item iavf_hash_pattern_list[] = {
 	{iavf_pattern_eth_ipv4_gtpu_eh_ipv4_tcp, IAVF_INSET_NONE,
 					&phint_eth_ipv4_gtpu_eh_ipv4_tcp},
 	{iavf_pattern_eth_ipv4_esp, IAVF_INSET_NONE, &phint_eth_ipv4_esp},
+	{iavf_pattern_eth_ipv4_udp_esp, IAVF_INSET_NONE,
+					&phint_eth_ipv4_udp_esp},
 	{iavf_pattern_eth_ipv4_ah, IAVF_INSET_NONE, &phint_eth_ipv4_ah},
 	{iavf_pattern_eth_ipv4_l2tpv3, IAVF_INSET_NONE,
 					&phint_eth_ipv4_l2tpv3},
@@ -157,6 +168,8 @@ static struct iavf_pattern_match_item iavf_hash_pattern_list[] = {
 	{iavf_pattern_eth_ipv6_tcp, IAVF_INSET_NONE, &phint_eth_ipv6_tcp},
 	{iavf_pattern_eth_ipv6_sctp, IAVF_INSET_NONE, &phint_eth_ipv6_sctp},
 	{iavf_pattern_eth_ipv6_esp, IAVF_INSET_NONE, &phint_eth_ipv6_esp},
+	{iavf_pattern_eth_ipv6_udp_esp, IAVF_INSET_NONE,
+					&phint_eth_ipv6_udp_esp},
 	{iavf_pattern_eth_ipv6_ah, IAVF_INSET_NONE, &phint_eth_ipv6_ah},
 	{iavf_pattern_eth_ipv6_l2tpv3, IAVF_INSET_NONE,
 					&phint_eth_ipv6_l2tpv3},
@@ -326,10 +339,18 @@ static struct iavf_pattern_match_item iavf_hash_pattern_list[] = {
 	FIELD_SELECTOR(VIRTCHNL_PROTO_HDR_IPV6_DST) | \
 	FIELD_SELECTOR(VIRTCHNL_PROTO_HDR_IPV6_PROT), {BUFF_NOUSED } }
 
+#define proto_hint_gtpu_ip_teid { \
+	VIRTCHNL_PROTO_HDR_GTPU_IP, \
+	FIELD_SELECTOR(VIRTCHNL_PROTO_HDR_GTPU_IP_TEID), {BUFF_NOUSED } }
+
 #define proto_hint_gtpu_eh_only { \
 	VIRTCHNL_PROTO_HDR_GTPU_EH, \
 	FIELD_FOR_PROTO_ONLY, {BUFF_NOUSED } }
 
+#define proto_hint_gtpu_ip_only { \
+	VIRTCHNL_PROTO_HDR_GTPU_IP, \
+	FIELD_FOR_PROTO_ONLY, {BUFF_NOUSED } }
+
 #define proto_hint_gtpu_up_only { \
 	VIRTCHNL_PROTO_HDR_GTPU_EH_PDU_UP, \
 	FIELD_FOR_PROTO_ONLY, {BUFF_NOUSED } }
@@ -520,6 +541,26 @@ struct virtchnl_proto_hdrs hdrs_hint_ipv4_udp_esp = {
 	proto_hint_udp_only, proto_hint_esp }
 };
 
+/* GTPU IP */
+struct virtchnl_proto_hdrs hdrs_hint_ipv4_src_gtpu_ip = {
+	TUNNEL_LEVEL_FIRST_INNER, PROTO_COUNT_TWO, {proto_hint_gtpu_ip_only,
+	proto_hint_ipv4_src }
+};
+
+struct virtchnl_proto_hdrs hdrs_hint_ipv4_dst_gtpu_ip = {
+	TUNNEL_LEVEL_FIRST_INNER, PROTO_COUNT_TWO, {proto_hint_gtpu_ip_only,
+	proto_hint_ipv4_dst }
+};
+
+struct virtchnl_proto_hdrs hdrs_hint_ipv4_gtpu_ip = {
+	TUNNEL_LEVEL_FIRST_INNER, PROTO_COUNT_TWO, {proto_hint_gtpu_ip_only,
+	proto_hint_ipv4 }
+};
+
+struct virtchnl_proto_hdrs hdrs_hint_teid_gtpu_ip = {
+	TUNNEL_LEVEL_FIRST_INNER, PROTO_COUNT_TWO, {proto_hint_gtpu_ip_teid}
+};
+
 /* GTPU EH */
 
 struct virtchnl_proto_hdrs hdrs_hint_ipv4_udp_src_gtpu_eh = {
@@ -1235,6 +1276,28 @@ struct iavf_hash_match_type iavf_hash_map_list[] = {
 
 struct iavf_hash_match_type iavf_gtpu_hash_map_list[] = {
 	/* GTPU */
+	/* GTPU IP */
+	/* GTPU IPV4*/
+	{ETH_RSS_L3_SRC_ONLY,
+		&hdrs_hint_ipv4_src_gtpu_ip,
+		IAVF_PHINT_IPV4_GTPU_IP | IAVF_PHINT_IPV4},
+	{ETH_RSS_L3_DST_ONLY,
+		&hdrs_hint_ipv4_dst_gtpu_ip,
+		IAVF_PHINT_IPV4_GTPU_IP | IAVF_PHINT_IPV4},
+	{ETH_RSS_IPV4 |
+		ETH_RSS_L3_SRC_ONLY,
+		&hdrs_hint_ipv4_src_gtpu_ip,
+		IAVF_PHINT_IPV4_GTPU_IP | IAVF_PHINT_IPV4},
+	{ETH_RSS_IPV4 |
+		ETH_RSS_L3_DST_ONLY,
+		&hdrs_hint_ipv4_dst_gtpu_ip,
+		IAVF_PHINT_IPV4_GTPU_IP | IAVF_PHINT_IPV4},
+	{ETH_RSS_IPV4,
+		&hdrs_hint_ipv4_gtpu_ip,
+		IAVF_PHINT_IPV4_GTPU_IP | IAVF_PHINT_IPV4},
+	{ETH_RSS_GTPU,
+		&hdrs_hint_teid_gtpu_ip,
+		IAVF_PHINT_IPV4_GTPU_IP | IAVF_PHINT_IPV4},
 	/* GTPU EH */
 	/* Inner IPV4 */
 	{ETH_RSS_L3_SRC_ONLY,
@@ -1789,8 +1852,12 @@ iavf_hash_parse_pattern(struct iavf_pattern_match_item *pattern_match_item,
 		}
 
 		switch (item->type) {
+		case RTE_FLOW_ITEM_TYPE_GTPU:
+			*phint |= IAVF_PHINT_IPV4_GTPU_IP;
+			break;
 		case RTE_FLOW_ITEM_TYPE_GTP_PSC:
 			psc = item->spec;
+			*phint &= ~IAVF_PHINT_IPV4_GTPU_IP;
 			if (!psc)
 				*phint |= IAVF_PHINT_IPV4_GTPU_EH;
 			else if (psc->pdu_type == IAVF_GTPU_EH_UPLINK)
@@ -1868,7 +1935,8 @@ iavf_hash_parse_action(const struct rte_flow_action actions[],
 			 */
 			rss_type = rte_eth_rss_hf_refine(rss_type);
 
-			if ((pattern_hint & IAVF_PHINT_IPV4_GTPU_EH) ||
+			if ((pattern_hint & IAVF_PHINT_IPV4_GTPU_IP) ||
+			    (pattern_hint & IAVF_PHINT_IPV4_GTPU_EH) ||
 			    (pattern_hint & IAVF_PHINT_IPV4_GTPU_EH_UPLINK) ||
 			    (pattern_hint & IAVF_PHINT_IPV4_GTPU_EH_DWNLINK)) {
 				hash_map_list = iavf_gtpu_hash_map_list;